require 'test_helper'

class TestBot < Balotelli::Base
end


class BaseTest < Minitest::Test
  def setup
    require_relative 'xyz'
    require_relative 'asdf'
    require_relative 'special_one'
  end

  def test_it_sets_up
    assert TestBot.instance_variable_get(:@routes)
    assert TestBot.instance_variable_get(:@modules)
    assert TestBot.instance_variable_get(:@cache)
  end

  def test_it_responds_to_run
    assert TestBot.respond_to?(:run)
  end

  def test_it_registes_module
    TestBot.register(Balotelli::Module::Asdf)
    assert Balotelli::Module::Asdf.commands_namespace == :asdf
    assert TestBot.instance_variable_get(:@modules)[:asdf] == Balotelli::Module::Asdf
    TestBot.register(Balotelli::Module::Xyz, "hoh")
    assert Balotelli::Module::Xyz.commands_namespace == :hoh
    assert TestBot.instance_variable_get(:@modules)[:hoh] == Balotelli::Module::Xyz
  end

  def test_it_registers_special
    TestBot.register_special(Balotelli::Module::SpecialOne)
    assert TestBot.match("asdfg")
  end

  def test_it_matches_module_routes
    TestBot.register(Balotelli::Module::Asdf)
    assert_equal TestBot.mod_match("asdf Yes, sir").pattern, /yes/i
    TestBot.register(Balotelli::Module::Xyz, "hoh")
    assert_equal TestBot.mod_match("!hoh Si si").pattern, /si/i
  end
end
