require 'test_helper'

class ToRoute
  include Balotelli::Core::Router

  def initialize
    setup_router
  end
end

class RouterTest < Minitest::Test
  def setup
    @route = ToRoute.new
  end

  def test_it_has_routes
    assert @route.instance_variable_get(:@routes)
  end

  def test_it_mathes_routes
    lam = -> { puts 'kk' }
    @route.on %r{ono}i, private: true, &lam
    first_match = @route.match('onOmatopeja', true)
    assert first_match.pattern == %r{ono}i
    assert first_match.block == lam
    refute @route.match('onOmatopeja', false)
    @route.on 'asdf', &lam
    assert @route.match('asdf')
    refute @route.match('asdf', true)
    @route.on %r{hi}i, private: :both, &lam
    assert @route.match('Hi')
    assert @route.match('hI', true)
  end
end
